from zope.app.annotation.interfaces import IAnnotations
from zope.app.schema.vocabulary import IVocabularyFactory
from zope.schema.vocabulary import SimpleTerm, SimpleVocabulary
from zope.component import adapts
from zope.interface import implements
from persistent.list import PersistentList
from persistent.dict import PersistentDict

from eea.rdfrepository.interfaces import IFeedDiscover, IFeedContent

KEY = 'eea.rdfrepository.discover'

class DiscoverAdapter(object):
    implements(IFeedDiscover)
    adapts(IFeedContent)

    def __init__(self, context):
        self.context = context
        annotations = IAnnotations(context)
        mapping = annotations.get(KEY)
        if mapping is None:
            discover =  { 'search_attrs': PersistentList() }
            mapping = annotations[KEY] = PersistentDict(discover)
        self.mapping = mapping

    #def search_attrs():
    def gets(self):
        anno = IAnnotations(self.context)
        mapping = anno.get(KEY)
        return list(mapping['search_attrs'])

    def sets(self, value):
        anno = IAnnotations(self.context)
        mapping = anno.get(KEY)
        mapping['search_attrs'] = PersistentList(value)
        #return property(get, set)
    #search_attrs = search_attrs(get, set)
    search_attrs = property(gets, sets)


class DiscoverAttributesVocabulary(object):
    implements(IVocabularyFactory)

    def __call__(self, context):
        terms = []
        terms.append(SimpleTerm('title', 'title', 'title'))
        terms.append(SimpleTerm('subject', 'subject', 'subject'))
        terms.append(SimpleTerm('description', 'description', 'description'))
        return SimpleVocabulary(terms)

DiscoverAttributesVocabularyFactory = DiscoverAttributesVocabulary()
