#
# Base TestCase for Audit
#

from Products.PloneTestCase import PloneTestCase
from Products.PloneTestCase.layer import onsetup
from Products.Five import zcml
from Products.Five import fiveconfigure

PRODUCTS = ('ATVocabularyManager',
            'FiveSite', 'EEAContentTypes',
            'ThemeCentre')

@onsetup
def setup_rdfrepository():
    fiveconfigure.debug_mode = True
    import Products.Five
    import Products.FiveSite
    import eea.themecentre
    zcml.load_config('meta.zcml', Products.Five)
    zcml.load_config('permissions.zcml', Products.Five)
    zcml.load_config('configure.zcml', Products.FiveSite)
    zcml.load_config('configure.zcml', eea.themecentre)
    fiveconfigure.debug_mode = False

    PloneTestCase.installProduct('ATVocabularyManager')
    PloneTestCase.installProduct('EEAContentTypes')
    PloneTestCase.installProduct('ThemeCentre')

setup_rdfrepository()
PloneTestCase.setupPloneSite(products=PRODUCTS)

class RDFRepositoryTestCase(PloneTestCase.FunctionalTestCase):
    """ A functional test case for testing the RDF repository.  """
