from Products.Five.site.localsite import enableLocalSiteHook
from zope.app.component.hooks import setSite
from zope.component import provideUtility, provideAdapter
#from zope.component import getAllUtilitiesRegisteredFor
from zope.interface import classImplements, alsoProvides
from eea.themecentre.interfaces import IThemeTagging
from eea.rdfrepository import tests
from eea.rdfrepository.tests.RDFRepositoryTestCase import RDFRepositoryTestCase
from eea.rdfrepository.rdfrepository import RDFRepository
from eea.rdfrepository.interfaces import IFeedDiscover, IFeedContent, IRDFRepository
#from eea.rdfrepository.interfaces import IRDFRepositoryPlugin
from eea.rdfrepository.discover import DiscoverAdapter
from os.path import dirname, join
from Acquisition import aq_base
#from zope.app.testing import ztapi
import unittest

class TestRDFRepository(RDFRepositoryTestCase):
    def afterSetUp(self):
        enableLocalSiteHook(self.portal)
        setSite(self.portal)

        self.setRoles(['Manager'])
        provideUtility(RDFRepository())
        provideAdapter(DiscoverAdapter)
        rdf_file = join(dirname(tests.__file__), 'sample.rdf')

        alsoProvides(self.portal, IRDFRepository)
        self.portal.portal_catalog.reindexObject(self.portal)

def test_suite():
    from zope.testing import doctest
    from Testing.ZopeTestCase import FunctionalDocFileSuite

    return unittest.TestSuite((
        FunctionalDocFileSuite('README.txt',
            test_class=TestRDFRepository,
            package='eea.rdfrepository',
            optionflags=doctest.NORMALIZE_WHITESPACE | doctest.ELLIPSIS,
            ),
        ))

if __name__ == '__main__':
    unittest.main(defaultTest='test_suite')
